#!/bin/bash



######################################################################################

VERSION=4.5.1
COMPHEP_DISTR=comphep-$VERSION
WDIR=`readlink -f ${1}`
CHEPDIR="/opt/comphep"
OSTYPE=$(uname)
CHEPTMPDIR="/tmp/comphep$(id -u)"
if [ -z "$LHAPDFPATH" ]
then
	LHAPDFLIBNAME=
else
	LHAPDFLIBNAME=LHAPDF
	LHAPDFLIBPATH=$LHAPDFPATH/lib
fi
cd $CHEPDIR
echo $WDIR
F77=$(cat F77)
CC=$(cat CC)
CFLAGS=$(cat CFLAGS)
CLIBS=$(cat CLIBS)
FORLIBS=$(cat FORLIBS)
RANLIB=$(cat RANLIB)
if [ $ROOTSYS ]
then
	ROOTFLAGS=$(cat ROOTFLAGS)
	ROOTLIBS=$(cat ROOTLIBS)
else
	ROOTFLAGS=
	ROOTLIBS=
fi

cd ${PWD}
pwd
####### Making directories
	if (test ! -d $WDIR)
	then 
	    mkdir -p $WDIR
	#else 
	  #echo " "
	  #echo "**************************************************************"
	  #echo " The directory WDIR=$WDIR exists!"
	  #echo " "
	  #echo " Overwrite?"
	  #echo " Press [Enter] to continue or ^C to stop."
	  #echo "**************************************************************"
	 # read
	fi
	if (test ! -d $WDIR/results); then mkdir -p $WDIR/results; fi
	if (test ! -d $WDIR/models);  then mkdir -p $WDIR/models; fi
	if (test ! -d $WDIR/tmp);     then mkdir -p $WDIR/tmp; fi
	if (test ! -d $WDIR/usr);     then mkdir -p $WDIR/usr; fi

	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/comphep > $WDIR/comphep
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/archiv > $WDIR/archiv
	cp $CHEPDIR/usr/comphep.ini $WDIR/comphep.ini
	cp $CHEPDIR/models/*.mdl $WDIR/models/.
if [ $LHAPDFPATH ]
then
	mv $WDIR/models/beams-lhapdf.mdl $WDIR/models/beams.mdl
	mv $WDIR/models/strfuns-lhapdf.mdl $WDIR/models/strfuns.mdl
fi
if [ $ROOTSYS ]
then
	rm -f $CHEPDIR/usr/.rtupler_tmp
	sed -e s!@RROOTT@!"$ROOTSYS"!g $CHEPDIR/usr/rtupler > $CHEPDIR/usr/.rtupler_tmp
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/.rtupler_tmp  > $WDIR/rtupler
	rm -f $CHEPDIR/usr/.rtupler_tmp
	chmod 744 $WDIR/rtupler
fi
	cp $CHEPDIR/usr/userFun* $WDIR/usr/.
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/Makefile         > $WDIR/usr/Makefile
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/Makefile.results > $WDIR/results/Makefile
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/diag_view        > $WDIR/results/diag_view
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/mk_tab           > $WDIR/mk_tab
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/mix              > $WDIR/mix
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/cascade          > $WDIR/cascade
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/translator       > $WDIR/translator
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/tab_view         > $WDIR/tab_view
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/slha.suspect     > $WDIR/SLHA.sh
	sed -e s!@CHEP@!"$PWD"!g $CHEPDIR/usr/n_comphep > /tmp/compheptmp
	sed -e s!@LHAPDF@!"$LHAPDFPATH"!g /tmp/compheptmp > $WDIR/results/n_comphep
	rm /tmp/compheptmp
	cp $CHEPDIR/usr/process.dat $WDIR/process.dat
	cp $CHEPDIR/usr/symb_batch.pl $WDIR/symb_batch.pl
	cp $CHEPDIR/usr/num_batch.pl $WDIR/num_batch.pl
	chmod 744 $WDIR/archiv
	chmod 744 $WDIR/comphep
	chmod 744 $WDIR/mk_tab
	chmod 744 $WDIR/mix
	chmod 744 $WDIR/cascade
	chmod 744 $WDIR/translator
	chmod 744 $WDIR/tab_view
	chmod 744 $WDIR/symb_batch.pl
	chmod 744 $WDIR/num_batch.pl
	chmod 744 $WDIR/SLHA.sh
	chmod 744 $WDIR/results/n_comphep
	chmod 744 $WDIR/results/diag_view

	make -C $WDIR/usr CC="$CC" CFLAGS="$CFLAGS" >> /dev/null

	echo " "
	echo " "
	echo "*****************************************************************"
	echo " Setup of the user directory for CompHEP-$VERSION has been"
	echo " successfully performed"
	echo " "
	echo " To start CompHEP go to the user directory $WDIR"
	echo " and enter the command './comphep'"
	echo "*****************************************************************"


if [ $LHAPDFPATH ]
then
	rm -f lib/lib$LHAPDFLIBNAME.a;
	ln -s $LHAPDFPATH/lib/lib$LHAPDFLIBNAME.a lib/.
fi

